#include<iostream>
#include<algorithm>
#include<vector>

using namespace std;

vector< pair<int, int> > binary_tree;

int find_in_tree(int a, int index){
    if(a==binary_tree[index].first){
        return index;
    }
    if(a>binary_tree[index].first || index*2>binary_tree.size()){
        return -1;
    }
    int c, b;
    c=find_in_tree(a, index*2);
    if(index*2+1<=binary_tree.size()){
        b=find_in_tree(a, index*2+1);
    }
    if(c==-1 && b==-1){
        return -1;
    }
    if(c!=-1){
        return c;
    }
    else{
        return b;
    }
}

void push(int a){
    binary_tree.push_back({a, 1});
    int index=binary_tree.size();
    while(index>1){
        if(binary_tree[index]>binary_tree[index/2]){
            swap(binary_tree[index], binary_tree[index/2]);
        }
    }
}

int main(){

    binary_tree.push_back({0, 0});

    int n;
    cin >> n;

    int t;
    cin >> t;
    binary_tree.push_back({t, 1});

    for(int i=1; i<n; i++){
        cin >> t;
        int fnd=find_in_tree(t, 1);
        if(fnd==-1){
            push(t);
        }
        else{
            binary_tree[fnd].second++;
        }
    }

    for(int i=1; i<binary_tree.size(); i++){
        if(binary_tree[i].second>n/2){
            cout << binary_tree[i].first;
        }
    }

    return 0;
}
