#include<iostream>

using namespace std;

bool is_used[205][205];
int mattrix[205][205];

void dfs (int i, int j, int times, bool& rez){
    is_used[i][j]=true;
    times++;
    if(times>3){
        rez=false;
    }
    if(times==3){
        rez=true;
    }
    if(mattrix[i][j]==mattrix[i+1][j] && !is_used[i+1][j]){
        //cout << times;
        dfs(i+1, j, times, rez);
    }
    if(mattrix[i][j]==mattrix[i-1][j] && !is_used[i-1][j]){
        //cout << times;
        dfs(i-1, j, times, rez);
    }
    if(mattrix[i][j]==mattrix[i][j+1] && !is_used[i][j+1]){
        //cout << times;
        dfs(i, j+1, times, rez);
    }
    if(mattrix[i][j]==mattrix[i][j-1] && !is_used[i][j-1]){
        //cout << times;
        dfs(i, j-1, times, rez);
    }
}

int main(){

    int t, m, n, b;
    bool does_match, matchana_li_napulno=true;
    cin >> t;

    for(int tt=0; tt<t; tt++){
        b=0;
        matchana_li_napulno=true;
        does_match=false;
        for(int i=0; i<205; i++){
            for(int j=0; j<205; j++){
                mattrix[i][j]=0;
                is_used[i][j]=0;
            }
        }

        cin >> m >> n;

        for(int i=1; i<=m; i++){
            for(int j=1; j<=n; j++){
                cin >> mattrix[i][j];
            }
        }

        for(int i=1; i<=m && matchana_li_napulno; i++){
            for(int j=1; j<=n && matchana_li_napulno; j++){
                if(!is_used[i][j] && mattrix[i][j]!=0){
                    dfs(i, j, 0, does_match);
                }
                if(!does_match){
                    cout << "NO\n";
                    matchana_li_napulno=false;
                }
            }
        }
        for(int i=1; i<=m; i++){
            for(int j=1; j<=n; j++){
                if(!is_used[i][j]){
                    b++;
                }
            }
        }
        if(matchana_li_napulno && b<=2){
            cout << "YES\n";
        }
        if(matchana_li_napulno && b>2){
            cout << "NO\n";
        }
    }

    return 0;
}

/*
2
4 8
1 2 2 2 6 7 7 9
1 4 4 3 6 7 8 9
1 0 4 3 6 8 8 9
10 10 10 3 0 5 5 5
2 6
1 1 2 2 1 1
0 1 0 2 0 1
*/
